# [71. Simplify Path](https://leetcode.com/problems/simplify-path/)

## 题目

Given an absolute path for a file (Unix-style), simplify it. Or in other words, convert it to the canonical path.

In a UNIX-style file system, a period . refers to the current directory. Furthermore, a double period .. moves the directory up a level. For more information, see: Absolute path vs relative path in Linux/Unix

Note that the returned canonical path must always begin with a slash /, and there must be only a single slash / between two directory names. The last directory name (if it exists) must not end with a trailing /. Also, the canonical path must be the shortest string representing the absolute path.



**Example 1**:

```

Input: "/home/"
Output: "/home"
Explanation: Note that there is no trailing slash after the last directory name.

```

**Example 2**:

```

Input: "/../"
Output: "/"
Explanation: Going one level up from the root directory is a no-op, as the root level is the highest level you can go.

```
**Example 3**:

```

Input: "/home//foo/"
Output: "/home/foo"
Explanation: In the canonical path, multiple consecutive slashes are replaced by a single one.

```

**Example 4**:

```

Input: "/a/./b/../../c/"
Output: "/c"

```


**Example 5**:

```

Input: "/a/../../b/../c//.//"
Output: "/c"

```

**Example 6**:

```

Input: "/a//b////c/d//././/.."
Output: "/a/b/c"

```

## 题目大意

给出一个 Unix 的文件路径，要求简化这个路径。这道题也是考察栈的题目。

## 解题思路

这道题笔者提交了好多次才通过，并不是题目难，而是边界条件很多，没考虑全一种情况就会出错。有哪些边界情况就看笔者的 test 文件吧。

## 代码

```go

package leetcode

import (
	"path/filepath"
	"strings"
)

// 解法一
func simplifyPath(path string) string {
	arr := strings.Split(path, "/")
	stack := make([]string, 0)
	var res string
	for i := 0; i < len(arr); i++ {
		cur := arr[i]
		//cur := strings.TrimSpace(arr[i]) 更加严谨的做法应该还要去掉末尾的空格
		if cur == ".." {
			if len(stack) > 0 {
				stack = stack[:len(stack)-1]
			}
		} else if cur != "." && len(cur) > 0 {
			stack = append(stack, arr[i])
		}
	}
	if len(stack) == 0 {
		return "/"
	}
	res = strings.Join(stack, "/")
	return "/" + res
}

// 解法二 golang 的官方库 API
func simplifyPath1(path string) string {
	return filepath.Clean(path)
}

```


----------------------------------------------
<div style="display: flex;justify-content: space-between;align-items: center;">
<p><a href="https://books.halfrost.com/leetcode/ChapterFour/0001~0099/0070.Climbing-Stairs/">⬅️上一页</a></p>
<p><a href="https://books.halfrost.com/leetcode/ChapterFour/0001~0099/0073.Set-Matrix-Zeroes/">下一页➡️</a></p>
</div>
