# [110. Balanced Binary Tree](https://leetcode.com/problems/balanced-binary-tree/)

## 题目


Given a binary tree, determine if it is height-balanced.

For this problem, a height-balanced binary tree is defined as:

a binary tree in which the depth of the two subtrees of every node never differ by more than 1.

**Example 1**:

Given the following tree [3,9,20,null,null,15,7]:

```

    3
   / \
  9  20
    /  \
   15   7

```

Return true.

**Example 2**:

Given the following tree [1,2,2,3,3,null,null,4,4]:


```

       1
      / \
     2   2
    / \
   3   3
  / \
 4   4

```

Return false.


## 题目大意

判断一棵树是不是平衡二叉树。平衡二叉树的定义是：树中每个节点都满足左右两个子树的高度差 <= 1 的这个条件。


## 解题思路

根据定义判断即可，计算树的高度是第 104 题。




## 代码

```go

package leetcode

/**
 * Definition for a binary tree node.
 * type TreeNode struct {
 *     Val int
 *     Left *TreeNode
 *     Right *TreeNode
 * }
 */
func isBalanced(root *TreeNode) bool {
	if root == nil {
		return true
	}
	leftHight := depth(root.Left)
	rightHight := depth(root.Right)
	return abs(leftHight-rightHight) <= 1 && isBalanced(root.Left) && isBalanced(root.Right)
}

func depth(root *TreeNode) int {
	if root == nil {
		return 0
	}
	return max(depth(root.Left), depth(root.Right)) + 1
}

```


----------------------------------------------
<div style="display: flex;justify-content: space-between;align-items: center;">
<p><a href="https://books.halfrost.com/leetcode/ChapterFour/0100~0199/0109.Convert-Sorted-List-to-Binary-Search-Tree/">⬅️上一页</a></p>
<p><a href="https://books.halfrost.com/leetcode/ChapterFour/0100~0199/0111.Minimum-Depth-of-Binary-Tree/">下一页➡️</a></p>
</div>
