# [503. Next Greater Element II](https://leetcode.com/problems/next-greater-element-ii/)

## 题目

Given a circular array (the next element of the last element is the first element of the array), print the Next Greater Number for every element. The Next Greater Number of a number x is the first greater number to its traversing-order next in the array, which means you could search circularly to find its next greater number. If it doesn't exist, output -1 for this number.

**Example 1**:

```

Input: [1,2,1]
Output: [2,-1,2]
Explanation: The first 1's next greater number is 2; 
The number 2 can't find next greater number; 
The second 1's next greater number needs to search circularly, which is also 2.

```

**Note**: The length of given array won't exceed 10000.

## 题目大意

题目给出数组 A，针对 A 中的每个数组中的元素，要求在 A 数组中找出比该元素大的数，A 是一个循环数组。如果找到了就输出这个值，如果找不到就输出 -1。


## 解题思路

这题是第 496 题的加强版，在第 496 题的基础上增加了循环数组的条件。这一题可以依旧按照第 496 题的做法继续模拟。更好的做法是用单调栈，栈中记录单调递增的下标。

## 代码

```go

package leetcode

// 解法一 单调栈
func nextGreaterElements(nums []int) []int {
	res := make([]int, 0)
	indexes := make([]int, 0)
	for i := 0; i < len(nums); i++ {
		res = append(res, -1)
	}
	for i := 0; i < len(nums)*2; i++ {
		num := nums[i%len(nums)]
		for len(indexes) > 0 && nums[indexes[len(indexes)-1]] < num {
			index := indexes[len(indexes)-1]
			res[index] = num
			indexes = indexes[:len(indexes)-1]
		}
		indexes = append(indexes, i%len(nums))
	}
	return res
}

// 解法二
func nextGreaterElements1(nums []int) []int {
	if len(nums) == 0 {
		return []int{}
	}
	res := []int{}
	for i := 0; i < len(nums); i++ {
		j, find := (i+1)%len(nums), false
		for j != i {
			if nums[j] > nums[i] {
				find = true
				res = append(res, nums[j])
				break
			}
			j = (j + 1) % len(nums)
		}
		if !find {
			res = append(res, -1)
		}
	}
	return res
}

```


----------------------------------------------
<div style="display: flex;justify-content: space-between;align-items: center;">
<p><a href="https://books.halfrost.com/leetcode/ChapterFour/0500~0599/0500.Keyboard-Row/">⬅️上一页</a></p>
<p><a href="https://books.halfrost.com/leetcode/ChapterFour/0500~0599/0507.Perfect-Number/">下一页➡️</a></p>
</div>
