# [706. Design HashMap](https://leetcode.com/problems/design-hashmap/)


## 题目

Design a HashMap without using any built-in hash table libraries.

To be specific, your design should include these functions:

- `put(key, value)` : Insert a (key, value) pair into the HashMap. If the value already exists in the HashMap, update the value.
- `get(key)`: Returns the value to which the specified key is mapped, or -1 if this map contains no mapping for the key.
- `remove(key)` : Remove the mapping for the value key if this map contains the mapping for the key.

**Example**:

    MyHashMap hashMap = new MyHashMap();
    hashMap.put(1, 1);          
    hashMap.put(2, 2);         
    hashMap.get(1);            // returns 1
    hashMap.get(3);            // returns -1 (not found)
    hashMap.put(2, 1);          // update the existing value
    hashMap.get(2);            // returns 1 
    hashMap.remove(2);          // remove the mapping for 2
    hashMap.get(2);            // returns -1 (not found)

**Note**:

- All keys and values will be in the range of `[0, 1000000]`.
- The number of operations will be in the range of `[1, 10000]`.
- Please do not use the built-in HashMap library.


## 题目大意

不使用任何内建的哈希表库设计一个哈希映射具体地说，你的设计应该包含以下的功能：

- put(key, value)：向哈希映射中插入(键,值)的数值对。如果键对应的值已经存在，更新这个值。
- get(key)：返回给定的键所对应的值，如果映射中不包含这个键，返回 -1。
- remove(key)：如果映射中存在这个键，删除这个数值对。

注意：

- 所有的值都在 [1, 1000000] 的范围内。
- 操作的总数目在 [1, 10000] 范围内。
- 不要使用内建的哈希库。


## 解题思路


- 简单题，设计一个 hashmap 的数据结构，要求有 `put(key, value)`，`get(key)`，`remove(key)`，这 3 个方法。设计一个 map 主要需要处理哈希冲突，一般都是链表法解决冲突。


## 代码

```go

package leetcode

const Len int = 100000

type MyHashMap struct {
	content [Len]*HashNode
}

type HashNode struct {
	key  int
	val  int
	next *HashNode
}

func (N *HashNode) Put(key int, value int) {
	if N.key == key {
		N.val = value
		return
	}
	if N.next == nil {
		N.next = &HashNode{key, value, nil}
		return
	}
	N.next.Put(key, value)
}

func (N *HashNode) Get(key int) int {
	if N.key == key {
		return N.val
	}
	if N.next == nil {
		return -1
	}
	return N.next.Get(key)
}

func (N *HashNode) Remove(key int) *HashNode {
	if N.key == key {
		p := N.next
		N.next = nil
		return p
	}
	if N.next != nil {
		return N.next.Remove(key)
	}
	return nil
}

/** Initialize your data structure here. */
func Constructor706() MyHashMap {
	return MyHashMap{}
}

/** value will always be non-negative. */
func (this *MyHashMap) Put(key int, value int) {
	node := this.content[this.Hash(key)]
	if node == nil {
		this.content[this.Hash(key)] = &HashNode{key: key, val: value, next: nil}
		return
	}
	node.Put(key, value)
}

/** Returns the value to which the specified key is mapped, or -1 if this map contains no mapping for the key */
func (this *MyHashMap) Get(key int) int {
	HashNode := this.content[this.Hash(key)]
	if HashNode == nil {
		return -1
	}
	return HashNode.Get(key)
}

/** Removes the mapping of the specified value key if this map contains a mapping for the key */
func (this *MyHashMap) Remove(key int) {
	HashNode := this.content[this.Hash(key)]
	if HashNode == nil {
		return
	}
	this.content[this.Hash(key)] = HashNode.Remove(key)
}

func (this *MyHashMap) Hash(value int) int {
	return value % Len
}

/**
 * Your MyHashMap object will be instantiated and called as such:
 * obj := Constructor();
 * obj.Put(key,value);
 * param_2 := obj.Get(key);
 * obj.Remove(key);
 */

```


----------------------------------------------
<div style="display: flex;justify-content: space-between;align-items: center;">
<p><a href="https://books.halfrost.com/leetcode/ChapterFour/0700~0799/0705.Design-HashSet/">⬅️上一页</a></p>
<p><a href="https://books.halfrost.com/leetcode/ChapterFour/0700~0799/0707.Design-Linked-List/">下一页➡️</a></p>
</div>
