# [856. Score of Parentheses](https://leetcode.com/problems/score-of-parentheses/)

## 题目

Given a balanced parentheses string S, compute the score of the string based on the following rule:

() has score 1
AB has score A + B, where A and B are balanced parentheses strings.
(A) has score 2 * A, where A is a balanced parentheses string.
 

**Example 1**:

```

Input: "()"
Output: 1

```

**Example 2**:

```

Input: "(())"
Output: 2

```

**Example 3**:

```

Input: "()()"
Output: 2

```

**Example 4**:

```

Input: "(()(()))"
Output: 6

```
 

**Note**:

1. S is a balanced parentheses string, containing only ( and ).
2. 2 <= S.length <= 50

## 题目大意

按照以下规则计算括号的分数：() 代表 1 分。AB 代表 A + B，A 和 B 分别是已经满足匹配规则的括号组。(A) 代表 2 * A，其中 A 也是已经满足匹配规则的括号组。给出一个括号字符串，要求按照这些规则计算出括号的分数值。


## 解题思路

按照括号匹配的原则，一步步的计算每个组合的分数入栈。遇到题目中的 3 种情况，取出栈顶元素算分数。


## 代码

```go

package leetcode

func scoreOfParentheses(S string) int {
	res, stack, top, temp := 0, []int{}, -1, 0
	for _, s := range S {
		if s == '(' {
			stack = append(stack, -1)
			top++
		} else {
			temp = 0
			for stack[top] != -1 {
				temp += stack[top]
				stack = stack[:len(stack)-1]
				top--
			}
			stack = stack[:len(stack)-1]
			top--
			if temp == 0 {
				stack = append(stack, 1)
				top++
			} else {
				stack = append(stack, temp*2)
				top++
			}
		}
	}
	for len(stack) != 0 {
		res += stack[top]
		stack = stack[:len(stack)-1]
		top--
	}
	return res
}

```


----------------------------------------------
<div style="display: flex;justify-content: space-between;align-items: center;">
<p><a href="https://books.halfrost.com/leetcode/ChapterFour/0800~0899/0853.Car-Fleet/">⬅️上一页</a></p>
<p><a href="https://books.halfrost.com/leetcode/ChapterFour/0800~0899/0862.Shortest-Subarray-with-Sum-at-Least-K/">下一页➡️</a></p>
</div>
