# [921. Minimum Add to Make Parentheses Valid](https://leetcode.com/problems/minimum-add-to-make-parentheses-valid/)

## 题目

Given a string S of '(' and ')' parentheses, we add the minimum number of parentheses ( '(' or ')', and in any positions ) so that the resulting parentheses string is valid.

Formally, a parentheses string is valid if and only if:

- It is the empty string, or
- It can be written as AB (A concatenated with B), where A and B are valid strings, or
- It can be written as (A), where A is a valid string.
Given a parentheses string, return the minimum number of parentheses we must add to make the resulting string valid.

 

**Example 1**:

```

Input: "())"
Output: 1

```

**Example 2**:

```

Input: "((("
Output: 3

```

**Example 3**:

```

Input: "()"
Output: 0

```

**Example 4**:

```

Input: "()))(("
Output: 4

```

**Note**:

1. S.length <= 1000
2. S only consists of '(' and ')' characters.

## 题目大意

给一个括号的字符串，如果能在这个括号字符串中的任意位置添加括号，问能使得这串字符串都能完美匹配的最少添加数是多少。

## 解题思路

这题也是栈的题目，利用栈进行括号匹配。最后栈里剩下几个括号，就是最少需要添加的数目。

## 代码

```go

package leetcode

func minAddToMakeValid(S string) int {
	if len(S) == 0 {
		return 0
	}
	stack := make([]rune, 0)
	for _, v := range S {
		if v == '(' {
			stack = append(stack, v)
		} else if (v == ')') && len(stack) > 0 && stack[len(stack)-1] == '(' {
			stack = stack[:len(stack)-1]
		} else {
			stack = append(stack, v)
		}
	}
	return len(stack)
}

```


----------------------------------------------
<div style="display: flex;justify-content: space-between;align-items: center;">
<p><a href="https://books.halfrost.com/leetcode/ChapterFour/0900~0999/0920.Number-of-Music-Playlists/">⬅️上一页</a></p>
<p><a href="https://books.halfrost.com/leetcode/ChapterFour/0900~0999/0922.Sort-Array-By-Parity-II/">下一页➡️</a></p>
</div>
