# [923. 3Sum With Multiplicity](https://leetcode.com/problems/3sum-with-multiplicity/)

## 题目

Given an integer array A, and an integer target, return the number of tuples i, j, k  such that i < j < k and A[i] + A[j] + A[k] == target.

As the answer can be very large, return it modulo 10^9 + 7.


**Example 1**:

```

Input: A = [1,1,2,2,3,3,4,4,5,5], target = 8
Output: 20
Explanation: 
Enumerating by the values (A[i], A[j], A[k]):
(1, 2, 5) occurs 8 times;
(1, 3, 4) occurs 8 times;
(2, 2, 4) occurs 2 times;
(2, 3, 3) occurs 2 times.

```


**Example 2**:

```

Input: A = [1,1,2,2,2,2], target = 5
Output: 12
Explanation: 
A[i] = 1, A[j] = A[k] = 2 occurs 12 times:
We choose one 1 from [1,1] in 2 ways,
and two 2s from [2,2,2,2] in 6 ways.

```


**Note**:

- 3 <= A.length <= 3000
- 0 <= A[i] <= 100
- 0 <= target <= 300


## 题目大意

这道题是第 15 题的升级版。给出一个数组，要求找到 3 个数相加的和等于 target 的解组合的个数，并且要求  i < j < k。解的组合个数不需要去重，相同数值不同下标算不同解(这里也是和第 15 题的区别)

## 解题思路

这一题大体解法和第 15 题一样的，只不过算所有解组合的时候需要一点排列组合的知识，如果取 3 个一样的数，需要计算 C n 3，去 2 个相同的数字的时候，计算 C n 2，取一个数字就正常计算。最后所有解的个数都加起来就可以了。


## 代码

```go

package leetcode

import (
	"sort"
)

func threeSumMulti(A []int, target int) int {
	mod := 1000000007
	counter := map[int]int{}
	for _, value := range A {
		counter[value]++
	}

	uniqNums := []int{}
	for key := range counter {
		uniqNums = append(uniqNums, key)
	}
	sort.Ints(uniqNums)

	res := 0
	for i := 0; i < len(uniqNums); i++ {
		ni := counter[uniqNums[i]]
		if (uniqNums[i]*3 == target) && counter[uniqNums[i]] >= 3 {
			res += ni * (ni - 1) * (ni - 2) / 6
		}
		for j := i + 1; j < len(uniqNums); j++ {
			nj := counter[uniqNums[j]]
			if (uniqNums[i]*2+uniqNums[j] == target) && counter[uniqNums[i]] > 1 {
				res += ni * (ni - 1) / 2 * nj
			}
			if (uniqNums[j]*2+uniqNums[i] == target) && counter[uniqNums[j]] > 1 {
				res += nj * (nj - 1) / 2 * ni
			}
			c := target - uniqNums[i] - uniqNums[j]
			if c > uniqNums[j] && counter[c] > 0 {
				res += ni * nj * counter[c]
			}
		}
	}
	return res % mod
}

```


----------------------------------------------
<div style="display: flex;justify-content: space-between;align-items: center;">
<p><a href="https://books.halfrost.com/leetcode/ChapterFour/0900~0999/0922.Sort-Array-By-Parity-II/">⬅️上一页</a></p>
<p><a href="https://books.halfrost.com/leetcode/ChapterFour/0900~0999/0924.Minimize-Malware-Spread/">下一页➡️</a></p>
</div>
