# [1017. Convert to Base -2](https://leetcode.com/problems/convert-to-base-2/)


## 题目

Given a number `N`, return a string consisting of `"0"`s and `"1"`s that represents its value in base **`-2`** (negative two).

The returned string must have no leading zeroes, unless the string is `"0"`.

**Example 1**:

    Input: 2
    Output: "110"
    Explantion: (-2) ^ 2 + (-2) ^ 1 = 2

**Example 2**:

    Input: 3
    Output: "111"
    Explantion: (-2) ^ 2 + (-2) ^ 1 + (-2) ^ 0 = 3

**Example 3**:

    Input: 4
    Output: "100"
    Explantion: (-2) ^ 2 = 4

**Note**:

1. `0 <= N <= 10^9`


## 题目大意

给出数字 N，返回由若干 "0" 和 "1"组成的字符串，该字符串为 N 的负二进制（base -2）表示。除非字符串就是 "0"，否则返回的字符串中不能含有前导零。

提示：

- 0 <= N <= 10^9



## 解题思路

- 给出一个十进制的数，要求转换成 -2 进制的数
- 这一题仿造十进制转二进制的思路，短除法即可。



## 代码

```go

package leetcode

import "strconv"

func baseNeg2(N int) string {
	if N == 0 {
		return "0"
	}
	res := ""
	for N != 0 {
		remainder := N % (-2)
		N = N / (-2)
		if remainder < 0 {
			remainder += 2
			N++
		}
		res = strconv.Itoa(remainder) + res
	}
	return res
}

```


----------------------------------------------
<div style="display: flex;justify-content: space-between;align-items: center;">
<p><a href="https://books.halfrost.com/leetcode/ChapterFour/1000~1099/1011.Capacity-To-Ship-Packages-Within-D-Days/">⬅️上一页</a></p>
<p><a href="https://books.halfrost.com/leetcode/ChapterFour/1000~1099/1018.Binary-Prefix-Divisible-By-5/">下一页➡️</a></p>
</div>
