# [1021. Remove Outermost Parentheses](https://leetcode.com/problems/remove-outermost-parentheses/)

## 题目

A valid parentheses string is either empty (""), "(" + A + ")", or A + B, where A and B are valid parentheses strings, and + represents string concatenation.  For example, "", "()", "(())()", and "(()(()))" are all valid parentheses strings.

A valid parentheses string S is primitive if it is nonempty, and there does not exist a way to split it into S = A+B, with A and B nonempty valid parentheses strings.

Given a valid parentheses string S, consider its primitive decomposition: S = P\_1 + P\_2 + ... + P\_k, where P\_i are primitive valid parentheses strings.

Return S after removing the outermost parentheses of every primitive string in the primitive decomposition of S.


**Example 1**:

```

Input: "(()())(())"
Output: "()()()"
Explanation: 
The input string is "(()())(())", with primitive decomposition "(()())" + "(())".
After removing outer parentheses of each part, this is "()()" + "()" = "()()()".

```

**Example 2**:

```

Input: "(()())(())(()(()))"
Output: "()()()()(())"
Explanation: 
The input string is "(()())(())(()(()))", with primitive decomposition "(()())" + "(())" + "(()(()))".
After removing outer parentheses of each part, this is "()()" + "()" + "()(())" = "()()()()(())".

```

**Example 3**:

```

Input: "()()"
Output: ""
Explanation: 
The input string is "()()", with primitive decomposition "()" + "()".
After removing outer parentheses of each part, this is "" + "" = "".

```

**Note**:

- S.length <= 10000
- S[i] is "(" or ")"
- S is a valid parentheses string
 

## 题目大意

题目要求去掉最外层的括号。

## 解题思路

用栈模拟即可。





## 代码

```go

package leetcode

// 解法一
func removeOuterParentheses(S string) string {
	now, current, ans := 0, "", ""
	for _, char := range S {
		if string(char) == "(" {
			now++
		} else if string(char) == ")" {
			now--
		}
		current += string(char)
		if now == 0 {
			ans += current[1 : len(current)-1]
			current = ""
		}
	}
	return ans
}

// 解法二
func removeOuterParentheses1(S string) string {
	stack, res, counter := []byte{}, "", 0
	for i := 0; i < len(S); i++ {
		if counter == 0 && len(stack) == 1 && S[i] == ')' {
			stack = stack[1:]
			continue
		}
		if len(stack) == 0 && S[i] == '(' {
			stack = append(stack, S[i])
			continue
		}
		if len(stack) > 0 {
			switch S[i] {
			case '(':
				{
					counter++
					res += "("
				}
			case ')':
				{
					counter--
					res += ")"
				}
			}
		}
	}
	return res
}

```


----------------------------------------------
<div style="display: flex;justify-content: space-between;align-items: center;">
<p><a href="https://books.halfrost.com/leetcode/ChapterFour/1000~1099/1020.Number-of-Enclaves/">⬅️上一页</a></p>
<p><a href="https://books.halfrost.com/leetcode/ChapterFour/1000~1099/1025.Divisor-Game/">下一页➡️</a></p>
</div>
